﻿Imports System
Imports System.Text
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports Telerik.Web.UI
Partial Public Class DropDownControl
    Inherits System.Web.UI.UserControl
    Private m_delimiter As String = ","

    Public Property Delimiter() As String
        Get
            Return m_delimiter
        End Get
        Set(ByVal value As String)
            m_delimiter = value
        End Set
    End Property

    Public ReadOnly Property DDList() As RadComboBox
        Get
            Return Me.CB1
        End Get
    End Property

    Protected Overrides Sub OnInit(ByVal e As EventArgs)
        ' Create the javascript functions with the client id appended to them.
        Dim sb As New StringBuilder()
        sb.Append("<script type='text/javascript'>")
        sb.Append("var cancelDropDownClosing")
        sb.Append(CB1.ClientID)
        sb.Append("=false; function onDropDownClosing")
        sb.Append(CB1.ClientID)
        sb.Append("(){cancelDropDownClosing")
        sb.Append(CB1.ClientID)
        sb.Append("= false;}")
        sb.Append("function onCheckBoxClick")
        sb.Append(CB1.ClientID)
        sb.Append("(){var combo=$find('")
        sb.Append(CB1.ClientID)
        sb.Append("');var chkall=$get(combo.get_id() + '_Header_SelectAll');if(AllSelected")
        sb.Append(CB1.ClientID)
        sb.Append("()==true){chkall.checked=true;}else{chkall.checked=false;}var text='';var values='';var items=combo.get_items();")
        sb.Append("for(var i=0;i<items.get_count();i++){var item=items.getItem(i);var chk1=$get(combo.get_id()+'_i'+i+'_chk1');")
        sb.Append("if(chk1.checked){text+=item.get_text()+'")
        sb.Append(Delimiter)
        sb.Append("';values+=item.get_value()+'")
        sb.Append(Delimiter)
        sb.Append("';}}text=removeLastDelimiter(text);values=removeLastDelimiter(values);if(text.length>0){combo.set_text(text);}else{combo.set_text('');}}")
        sb.Append("function AnyOneSelected")
        sb.Append(CB1.ClientID)
        sb.Append("(){var combo=$find('")
        sb.Append(CB1.ClientID)
        sb.Append("');var items=combo.get_items();for(var i=0;i<items.get_count();i++){var item=items.getItem(i);")
        sb.Append("var chk1=$get(combo.get_id()+'_i'+i+'_chk1');if(chk1.checked){return true;}}return false;}")
        sb.Append("function AllSelected")
        sb.Append(CB1.ClientID)
        sb.Append("(){var combo=$find('")
        sb.Append(CB1.ClientID)
        sb.Append("');var items=combo.get_items();for(var i=0;i<items.get_count();i++){var item=items.getItem(i);")
        sb.Append("var chk1=$get(combo.get_id()+'_i'+i+'_chk1');if(chk1.checked==false){return false;}}return true;}")
        sb.Append("function SelectAllClick")
        sb.Append(CB1.ClientID)
        sb.Append("(chk){var selectAll=true; if(AnyOneSelected")
        sb.Append(CB1.ClientID)
        sb.Append("()==true)selectAll=true;if(AllSelected")
        sb.Append(CB1.ClientID)
        sb.Append("()==true)selectAll=false;var text='';var values='';var combo = $find('")
        sb.Append(CB1.ClientID)
        sb.Append("');var items=combo.get_items();for(var i=0;i<items.get_count();i++){var item=items.getItem(i);")
        sb.Append("var chk1=$get(combo.get_id()+'_i'+i+'_chk1');if(selectAll)chk1.checked=true;else chk1.checked=false;")
        sb.Append("if(chk1.checked){text += item.get_text()+'")
        sb.Append(Delimiter)
        sb.Append("';values+=item.get_value()+'")
        sb.Append(Delimiter)
        sb.Append("';}}text=removeLastDelimiter(text);values=removeLastDelimiter(values);if(text.length>0)combo.set_text(text);else ")
        sb.Append("combo.set_text('');}</script>")
        Dim js As String = sb.ToString()

        ' Gets the executing web page
        Dim page As Page = TryCast(HttpContext.Current.CurrentHandler, Page)

        ' Register the javascript on the page with the client id appended.
        page.ClientScript.RegisterClientScriptBlock(GetType(DropDownControl), "DDC_" + CB1.ClientID, js)
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        ' Create the javascript functions.
        If Not Me.IsPostBack Then
            ' Add the events
            Me.CB1.OnClientDropDownClosed = "onDropDownClosing" + CB1.ClientID
            TryCast(CB1.Header.FindControl("SelectAll"), CheckBox).Attributes("onclick") = "SelectAllClick" + CB1.ClientID + "(this)"
        End If
    End Sub

    Protected Sub CB1_ItemDataBound(ByVal sender As Object, ByVal e As RadComboBoxItemEventArgs)
        TryCast(e.Item.FindControl("chk1"), CheckBox).Attributes("onclick") = "onCheckBoxClick" + CB1.ClientID + "(this)"
    End Sub

    Public Function GetCheckBoxValues() As String
        Dim sbValues As New StringBuilder()
        For Each rcbItem As Telerik.Web.UI.RadComboBoxItem In DDList.Items
            'If the box is checked return a value
            Dim cb As CheckBox = DirectCast(rcbItem.FindControl("chk1"), CheckBox)
            If cb IsNot Nothing AndAlso cb.Checked Then
                sbValues.Append(rcbItem.Text)
                sbValues.Append(Delimiter)
            End If
        Next
        'Remove Trailing comma
        Dim str As String = sbValues.ToString()
        If str.EndsWith(Delimiter) Then
            Return str.Remove(sbValues.Length - 1, 1)
        End If
        Return str
    End Function

    Public Sub SetCheckBoxValues(ByVal csv As String)
        ' First clear all checks.
        For Each item As RadComboBoxItem In DDList.Items
            Dim chkbox As CheckBox = DirectCast(item.FindControl("chk1"), CheckBox)
            If chkbox IsNot Nothing Then
                chkbox.Checked = False
            End If
        Next

        ' Find each item in the list and set the check and combo text value.
        Dim values As String() = csv.Split(","c)
        Dim text As String = String.Empty
        For i As Integer = 0 To values.Length - 1
            Dim item As RadComboBoxItem = DDList.FindItemByValue(values(i))
            Dim chkbox As CheckBox = DirectCast(item.FindControl("chk1"), CheckBox)
            If text.Equals(String.Empty) Then
                text = String.Format("{0}", item.Text)
            Else
                text = String.Format("{0}{1} {2}", text, Delimiter, item.Text)
            End If
            chkbox.Checked = True
        Next
        DDList.Text = text
        ' This doesn't do anything!
    End Sub
End Class

